## nihstro 0.0~git20211107.e924e21

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(nihstro)

find_package(Boost COMPONENTS program_options unit_test_framework)

add_definitions(-std=c++11)

include_directories(include)

add_executable(nihstro-disassemble src/disassembler.cpp src/parser_shbin.cpp)
install(TARGETS nihstro-disassemble DESTINATION bin)

# TODO: Re-enable
# add_subdirectory(examples/inline_assembler/simple)

# TODO: What if program_options was found but not unit_test_framework?
if(Boost_FOUND)
    set(PARSER_SRCS src/parser_assembly.cpp
                    src/preprocessor.cpp
                    src/parser_assembly/common.cpp
                    src/parser_assembly/compare.cpp
                    src/parser_assembly/declaration.cpp
                    src/parser_assembly/flowcontrol.cpp
                    src/parser_assembly/floatop.cpp)

    include_directories(${Boost_INCLUDE_DIRS})
    add_executable(nihstro-assemble src/assembler.cpp ${PARSER_SRCS})
    target_link_libraries(nihstro-assemble ${Boost_PROGRAM_OPTIONS_LIBRARY})
    install(TARGETS nihstro-assemble DESTINATION bin)

    # tests
    if(Boost_UNIT_TEST_FRAMEWORK_FOUND)
        add_executable(test-parser src/tests/parser.cpp ${PARSER_SRCS})
        target_compile_definitions(test-parser PUBLIC -DBOOST_TEST_DYN_LINK -DBOOST_TEST_MAIN)
        target_link_libraries(test-parser ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
        enable_testing()
        add_test(ParserTests test-parser)

        add_executable(test-source-tree-iterator src/tests/source_tree_iterator.cpp)
        target_compile_definitions(test-source-tree-iterator PUBLIC -DBOOST_TEST_DYN_LINK -DBOOST_TEST_MAIN)
        target_link_libraries(test-source-tree-iterator ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
        add_test(ParserTests test-source-tree-iterator)
    else()
        message(WARNING "Boost testing framework not found => not building assembler tests")
    endif()
else()
    message(WARNING "Boost not found => not building assembler")
endif()

=== examples/assembler/cube/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------

ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

ifeq ($(strip $(NIHSTRO)),)
$(error "Please set NIHSTRO in your environment. export NIHSTRO=<path to>nihstro-assemble")
endif

TOPDIR ?= $(CURDIR)
include $(DEVKITARM)/3ds_rules

#---------------------------------------------------------------------------------
# TARGET is the name of the output
# BUILD is the directory where object files & intermediate files will be placed
# SOURCES is a list of directories containing source code
# DATA is a list of directories containing data files
# INCLUDES is a list of directories containing header files
#
# NO_SMDH: if set to anything, no SMDH file is generated.
# APP_TITLE is the name of the app stored in the SMDH file (Optional)
# APP_DESCRIPTION is the description of the app stored in the SMDH file (Optional)
# APP_AUTHOR is the author of the app stored in the SMDH file (Optional)
# ICON is the filename of the icon (.png), relative to the project folder.
#   If not set, it attempts to use one of the following (in this order):
#     - <Project name>.png
#     - icon.png
#     - <libctru folder>/default_icon.png
#---------------------------------------------------------------------------------
TARGET		:=	$(notdir $(CURDIR))
BUILD		:=	build
SOURCES		:=	source
DATA		:=	data
INCLUDES	:=	include

#---------------------------------------------------------------------------------
# options for code generation
#---------------------------------------------------------------------------------
ARCH	:=	-march=armv6k -mtune=mpcore -mfloat-abi=hard

CFLAGS	:=	-g -Wall -O2 -mword-relocations \
			-fomit-frame-pointer -ffast-math \
			$(ARCH)

CFLAGS	+=	$(INCLUDE) -DARM11 -D_3DS

CXXFLAGS	:= $(CFLAGS) -fno-rtti -std=gnu++11

ASFLAGS	:=	-g $(ARCH)
LDFLAGS	=	-specs=3dsx.specs -g $(ARCH) -Wl,-Map,$(notdir $*.map)

LIBS	:= -lctru -lm

#---------------------------------------------------------------------------------
# list of directories containing libraries, this must be the top level containing
# include and lib
#---------------------------------------------------------------------------------
LIBDIRS	:= $(CTRULIB)


#---------------------------------------------------------------------------------
# no real need to edit anything past this point unless you need to add additional
# rules for different file extensions
#---------------------------------------------------------------------------------
ifneq ($(BUILD),$(notdir $(CURDIR)))
#---------------------------------------------------------------------------------

export OUTPUT	:=	$(CURDIR)/$(TARGET)
export TOPDIR	:=	$(CURDIR)

export VPATH	:=	$(foreach dir,$(SOURCES),$(CURDIR)/$(dir)) \
			$(foreach dir,$(DATA),$(CURDIR)/$(dir))

export DEPSDIR	:=	$(CURDIR)/$(BUILD)

CFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.c)))
CPPFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.cpp)))
SFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.s)))
BINFILES	:=	$(foreach dir,$(DATA),$(notdir $(wildcard $(dir)/*.*)))

#---------------------------------------------------------------------------------
# use CXX for linking C++ projects, CC for standard C
#---------------------------------------------------------------------------------
ifeq ($(strip $(CPPFILES)),)
#---------------------------------------------------------------------------------
	export LD	:=	$(CC)
#---------------------------------------------------------------------------------
else
#---------------------------------------------------------------------------------
	export LD	:=	$(CXX)
#---------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------

export OFILES	:=	$(addsuffix .o,$(BINFILES)) \
			$(CPPFILES:.cpp=.o) $(CFILES:.c=.o) $(SFILES:.s=.o)

export INCLUDE	:=	$(foreach dir,$(INCLUDES),-I$(CURDIR)/$(dir)) \
			$(foreach dir,$(LIBDIRS),-I$(dir)/include) \
			-I$(CURDIR)/$(BUILD)

export LIBPATHS	:=	$(foreach dir,$(LIBDIRS),-L$(dir)/lib)

ifeq ($(strip $(ICON)),)
	icons := $(wildcard *.png)
	ifneq (,$(findstring $(TARGET).png,$(icons)))
		export APP_ICON := $(TOPDIR)/$(TARGET).png
	else
		ifneq (,$(findstring icon.png,$(icons)))
			export APP_ICON := $(TOPDIR)/icon.png
		endif
	endif
else
	export APP_ICON := $(TOPDIR)/$(ICON)
endif

.PHONY: $(BUILD) clean all

#---------------------------------------------------------------------------------
all: $(BUILD)

$(BUILD):
	@[ -d $@ ] || mkdir -p $@
	@make --no-print-directory -C $(BUILD) -f $(CURDIR)/Makefile

#---------------------------------------------------------------------------------
clean:
	@echo clean ...
	@rm -fr $(BUILD) $(TARGET).3dsx $(OUTPUT).smdh $(TARGET).elf test.vsh.shbin


#---------------------------------------------------------------------------------
else

DEPENDS	:=	$(OFILES:.o=.d)

#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
ifeq ($(strip $(NO_SMDH)),)
.PHONY: all
all	:	$(OUTPUT).3dsx $(OUTPUT).smdh
endif
$(OUTPUT).3dsx	:	$(OUTPUT).elf
$(OUTPUT).elf	:	$(OFILES)

#---------------------------------------------------------------------------------
# you need a rule like this for each extension you use as binary data
#---------------------------------------------------------------------------------
%.bin.o	:	%.bin
#---------------------------------------------------------------------------------
	@echo $(notdir $<)
	@$(bin2o)

# WARNING: This is not the right way to do this! TODO: Do it right!
#---------------------------------------------------------------------------------
%.vsh.o	:	%.vsh
#---------------------------------------------------------------------------------
	@echo $(notdir $<)
	@$(NIHSTRO)/nihstro-assemble --output ../$(notdir $<).shbin $<
	@bin2s ../$(notdir $<).shbin | $(PREFIX)as -o $@
	@echo "extern const u8" `(echo $(notdir $<).shbin | sed -e 's/^\([0-9]\)/_\1/' | tr . _)`"_end[];" > `(echo $(notdir $<).shbin | tr . _)`.h
	@echo "extern const u8" `(echo $(notdir $<).shbin | sed -e 's/^\([0-9]\)/_\1/' | tr . _)`"[];" >> `(echo $(notdir $<).shbin | tr . _)`.h
	@echo "extern const u32" `(echo $(notdir $<).shbin | sed -e 's/^\([0-9]\)/_\1/' | tr . _)`_size";" >> `(echo $(notdir $<).shbin | tr . _)`.h

-include $(DEPENDS)

#---------------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------------

=== examples/inline_assembler/simple/CMakeLists.txt ===
add_executable(simple simple.cpp)

=== debian/changelog ===
nihstro (0.0~git20211107.e924e21-2) unstable; urgency=medium

  * Source only upload.

 -- David James <davidjamescastor215@proton.me>  Thu, 04 Jan 2024 12:58:04 +0000

nihstro (0.0~git20211107.e924e21-1) unstable; urgency=medium

  * Initial release. (Closes: #1056551)

 -- David James <davidjamescastor215@proton.me>  Tue, 21 Nov 2023 18:05:58 +0000

=== debian/control ===
Source: nihstro
Section: devel
Priority: optional
Maintainer: David James <davidjamescastor215@proton.me>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libboost-test-dev,
 libboost-program-options-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/neobrain/nihstro
Vcs-Browser: https://salsa.debian.org/debian/nihstro
Vcs-Git: https://salsa.debian.org/debian/nihstro.git

Package: nihstro-tools
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: 3DS shader tools
 nihstro is a collection of tools for 3DS shaders targeted at homebrew 
 development and/or reverse engineering. Currently, it supports assembling 
 3DS shader binaries from assembly source code and disassembling shaders from 
 shbin files. It also provides C++ interfaces for analyzing and runtime-
 compiling shaders.

Package: nihstro-headers
Architecture: all
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: 3DS shader development headers
 Headers for development with nihstro

=== debian/rules ===
#!/usr/bin/make -f

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CMAKE_BUILD_OPTIONS := \
    -DCMAKE_INSTALL_PREFIX=/usr

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS)

override_dh_auto_install:
	mkdir -p debian/tmp/usr/include
	cp -r include/* debian/tmp/usr/include
	dh_auto_install --destdir=debian/tmp

=== debian/watch ===
version=4
opts=mode=git \
https://github.com/neobrain/nihstro.git HEAD

## nihstro 0.0~git20240505.f4d8659

=== debian/changelog ===
nihstro (0.0~git20240505.f4d8659-1) unstable; urgency=medium

  * New upstream version 0.0~git20240505.f4d8659 (Closes: #1110599)
  * Add gbp.conf
  * Add patch to bump minimum CMake version to 3.5 (Closes: #1113325)
  * Update years in d/copyright
  * Remove redundant --as-needed linker flag
  * Changes to d/control
    - Update standards version to 4.7.2
    - Fix trailing whitespace
    - Remove redundant Rules-requires-root
    - Update package description
  * Update d/watch to version 5

 -- David James <davidjamescastor215@proton.me>  Thu, 11 Dec 2025 16:46:44 +0000

=== debian/control ===
Source: nihstro
Section: devel
Priority: optional
Maintainer: David James <davidjamescastor215@proton.me>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libboost-test-dev,
 libboost-program-options-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/neobrain/nihstro
Vcs-Browser: https://salsa.debian.org/debian/nihstro
Vcs-Git: https://salsa.debian.org/debian/nihstro.git

Package: nihstro-tools
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: 3DS shader tools
 Nihstro is a collection of tools for 3DS shaders targeted at homebrew
 development and/or reverse engineering. Currently, it supports assembling
 3DS shader binaries from assembly source code and disassembling shaders from
 shbin files. It also provides C++ interfaces for analyzing and runtime-
 compiling shaders.
 .
 This package contains binaries for assembling and disassembling 3DS shader
 code.

Package: nihstro-headers
Architecture: all
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: 3DS shader development headers
 Nihstro is a collection of tools for 3DS shaders targeted at homebrew
 development and/or reverse engineering. Currently, it supports assembling
 3DS shader binaries from assembly source code and disassembling shaders from
 shbin files. It also provides C++ interfaces for analyzing and runtime-
 compiling shaders.
 .
 This package contains headers for development with nihstro

=== debian/rules ===
--- 
+++ 
@@ -5,8 +5,6 @@
 
 # Package maintainers to append CFLAGS.
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-# Package maintainers to append LDFLAGS.
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 CMAKE_BUILD_OPTIONS := \
     -DCMAKE_INSTALL_PREFIX=/usr
